//#14.00Aa WDSaisieRiche.JS
//VersionVI: 30F140026t
// Le seul support technique disponible pour cette librairie est
// accessible a travers le service "Assistance Directe".

// Classe de base de manipulation des boutons
// Sert aussi pour les boutons d'action simple
function WDBarreBouton (oObjetParent, oBouton, sCommande, oParamCommande)
{
	// Si on construit directement la classe : appele l'init
	if (oObjetParent)
	{
		this._Init(oObjetParent, oBouton, sCommande, oParamCommande);
	}
}

WDBarreBouton.prototype =
{
//	m_oObjetParent:		null,
//	m_oBouton:			null,

	// Etat des boutons
	nEtat_Normal:		0,
	nEtat_Survol:		1,
	nEtat_Actif:		2,

	// Initialisation
	_Init:function (oObjetParent, oBouton, sCommande, oParamCommande)
	{
		this.m_oObjetParent = oObjetParent;
		this.m_oBouton = oBouton;
		this.m_sCommande = sCommande;
		this.m_oParamCommande = oParamCommande;

		// Hook les methodes des boutons
		var oThis = this;
		if (bIE)
		{
			this.m_oBouton.onmouseover = function () { oThis.OnMouseOver(event); };
			this.m_oBouton.onmouseout = function () { oThis.OnMouseOut(event); };
			this.m_oBouton.onclick = function () { oThis.OnClick(event); };
		}
		else
		{
			this.m_oBouton.onmouseover = function (event) { oThis.OnMouseOver(event); };
			this.m_oBouton.onmouseout = function (event) { oThis.OnMouseOut(event); };
			this.m_oBouton.onclick = function (event) { oThis.OnClick(event); };
		}
	},

	// Gestion de la souris
	OnMouseOver:function (oEvent)
	{
		// La souris est au dessus du champ
		this.m_bSurvol = true;

		// Rafraichit le bouton
		this.RafEtatSimple(oEvent);
	},

	OnMouseOut:function (oEvent)
	{
		// La souris n'est plus au dessus du champ
		delete this.m_bSurvol;

		// Rafraichit le bouton
		this.RafEtatSimple(oEvent);
	},

	OnClick:function (oEvent)
	{
		// Execute la commande : methode definie dans les classes derivees
		this.ExecuteCommande(oEvent);

		// Rafraichit le bouton
		// => inutile car fait par la gestion des commandes
//		this.RafEtatSimple(oEvent);
	},

	// Execute la commande
	ExecuteCommande:function (oEvent)
	{
		// Execute la fonction
		this.m_oObjetParent[this.m_sCommande](oEvent, this.m_oParamCommande);
	},

	// Rafraichit le bouton : methode par defaut
	RafEtatSimple:function (oEvent)
	{
		this.RafEtat(oEvent, this.m_oObjetParent.oGetParamEtat(oEvent, false));
	},

	// Rafraichit le bouton : methode par defaut
	RafEtat:function (oEvent, oDataEtat)
	{
		// Calcul de l'etat de survol du bouton
		var nEtat = this.m_bSurvol ? this.nEtat_Survol : this.nEtat_Normal;

		// Applique ensuite l'etat d'activation
		nEtat = this.nGetEtatSpecifique(oEvent, nEtat, oDataEtat);

		// Puis dessine l'etat
		if (nEtat != this.m_nEtat)
		{
			if (nEtat != this.nEtat_Normal)
			{
				this.m_nEtat = nEtat;
			}
			else
			{
				delete this.m_nEtat;
			}
			this.m_oBouton.style.backgroundImage = this.m_oObjetParent.sGetImageBouton(nEtat);
		}
	},

	// Calcule l'etat specifique du bouton : inchange
	nGetEtatSpecifique:function (oEvent, nEtat, oDataEtat)
	{
		return nEtat;
	}
}

// Manipulation d'un bouton On/Off du champ de saisie
function WDBarreBoutonOnOff (oObjetParent, oBouton, sCommande, oParamCommande)
{
	// Si on construit directement la classe : appele l'init
	if (oObjetParent)
	{
		this._Init(oObjetParent, oBouton, sCommande, oParamCommande);
	}
}

// Declare l'heritage
WDBarreBoutonOnOff.prototype = new WDBarreBouton();
// Surcharge le constructeur qui a ete efface
WDBarreBoutonOnOff.prototype.constructor = WDBarreBoutonOnOff;

// Declare les fonction une par une

// Applique ensuite l'etat d'activation
WDBarreBoutonOnOff.prototype.nGetEtatSpecifique = function (oEvent, nEtat, oDataEtat)
{
	// Si on a un etat surcharge
	// Appele la methode des classes derive de calcul de l'etat
	if (this.bActif(oEvent, oDataEtat))
	{
		return this.nEtat_Actif;
	}
	else
	{
		return WDBarreBouton.prototype.nGetEtatSpecifique.apply(this, [oEvent, nEtat, oDataEtat]);
	}
}

// Pas de surcharge de l'etat par defaut
WDBarreBoutonOnOff.prototype.bEtatSurcharge = function (oEvent, oDataEtat)
{
	return false;
}

// Manipulation d'un bouton dropdown du champ de saisie
function WDBarreBoutonPopup (oObjetParent, oBouton, sCommande, oParamCommande, oPopup)
{
	// Si on construit directement la classe : appele l'init
	if (oObjetParent)
	{
		this._Init(oObjetParent, oBouton, sCommande, oParamCommande, oPopup);
	}
}

// Declare l'heritage
WDBarreBoutonPopup.prototype = new WDBarreBouton();
// Surcharge le constructeur qui a ete efface
WDBarreBoutonPopup.prototype.constructor = WDBarreBoutonPopup;

// Declare les fonction une par une

// Surcharge de l'initialisateur
WDBarreBoutonPopup.prototype._Init = function (oObjetParent, oBouton, sCommande, oParamCommande, oPopup)
{
	// Appel de l'init de la classe de base
	WDBarreBouton.prototype._Init.apply(this, [oObjetParent, oBouton, sCommande, oParamCommande]);

	this.m_oPopup = oPopup;

	// Hook les methodes des boutons
	var oThis = this;
	var fClickPopup;
	if (bIE)
	{
		this.m_oBouton.getElementsByTagName("IMG")[0].onclick = function () { oThis.OnClick(event); };
		fClickPopup = function () { oThis.OnClickP(event); return bStopPropagation(event); };
	}
	else
	{
		this.m_oBouton.getElementsByTagName("IMG")[0].onclick = function (event) { oThis.OnClick(event); }
		fClickPopup = function (event) { oThis.OnClickP(event); return bStopPropagation(event); };
	}

	// Et les clics de la popup
	var tabTD = this.m_oPopup.getElementsByTagName("TD");
	for (var oTD in tabTD)
	{
		tabTD[oTD].onmousedown = fClickPopup;
	}

	this.m_bSurvol = false;
}

// Surcharge des fonctions de survol
WDBarreBoutonPopup.prototype.OnMouseOver = function (oEvent)
{
	// Filtre les cas ou le focus reste dans le TD
	if (!this.m_bSurvol)
	{
		// Rappel de la methode de la classe de base
		WDBarreBouton.prototype.OnMouseOver.apply(this, [oEvent]);
	}
}
WDBarreBoutonPopup.prototype.OnMouseOut = function (oEvent)
{
	// Detecte si la souris quitte vraiment l'objet
	var oDestination = bIE ? oEvent.toElement : oEvent.relatedTarget;
	if (bEstFils(oDestination, this.m_oBouton, document))
	{
		// L'element qui recoit la souris est encore dans le bouton : ne masque pas la popup
		return;
	}

	// Masque la popup
	this.m_oPopup.style.display = "none";

	// Rappel de la methode de la classe de base
	WDBarreBouton.prototype.OnMouseOut.apply(this, [oEvent]);
}

// Execute la commande : affiche la popup
WDBarreBoutonPopup.prototype.ExecuteCommande = function (oEvent)
{
	this.m_oPopup.style.display = "block";
}

// Clic sur un element : a definir dans les classes derivees
WDBarreBoutonPopup.prototype.OnClickP = function (oEvent)
{
	// Ferme la popup
	this.m_oPopup.style.display = "none";

	// L'element n'est plus survole
	WDBarreBouton.prototype.OnMouseOut.apply(this, [oEvent]);

	// Pour une raison non claire, on a un evenement MouseOver appele apres avoir masque le menu : on le bloque
	var oThis = this;
	setTimeout(function () { oThis.OnMouseOut( bIE ? { toElement:null} : { relatedTarget:null} ); }, 100);
}

// Manipulation d'une popup "menu"
function WDBarreBoutonPopupMenu (oObjetParent, oBouton, sCommande, oPopup, tabOptions)
{
	// Appel explicite de l'initialisation de la classe de base
	if (oObjetParent)
	{
		this._Init(oObjetParent, oBouton, sCommande, null, oPopup, tabOptions);
	}
}

// Declare l'heritage
WDBarreBoutonPopupMenu.prototype = new WDBarreBoutonPopup();
// Surcharge le constructeur qui a ete efface
WDBarreBoutonPopupMenu.prototype.constructor = WDBarreBoutonPopupMenu;
WDBarreBoutonPopupMenu.prototype.nOptionSurvol = -1;

// Declare les fonction une par une

// Initialisation du menu
WDBarreBoutonPopupMenu.prototype._Init = function (oObjetParent, oBouton, sCommande, oParamCommande, oPopup, tabOptions)
{
	// Appel de la methode de la classe de base
	WDBarreBoutonPopup.prototype._Init.apply(this, [oObjetParent, oBouton, sCommande, oParamCommande, oPopup]);

	// Memorise le tableau des options
	this.m_tabOptions = tabOptions;

	// Et fixe le texte dans les options
	var oThis = this;
	var i;
	var nLimiteI = this.m_tabOptions.length
	for (i = 0; i < nLimiteI; i++)
	{
		var oSPAN = document.createElement("SPAN");
		var oTexte = document.createTextNode(this.m_tabOptions[i].sTexte);
		oSPAN.appendChild(oTexte);
		this.m_tabOptions[i].oTD.appendChild(oSPAN);
		this.m_tabOptions[i].oTD.noWrap = "true";
		if (bIE)
		{
			this.m_tabOptions[i].oTD.onmouseover = function () { oThis.OnMouseOverMenu(event); };
			this.m_tabOptions[i].oTD.onmouseout = function () { oThis.OnMouseOutMenu(event); };
		}
		else
		{
			this.m_tabOptions[i].oTD.onmouseover = function (event) { oThis.OnMouseOverMenu(event); };
			this.m_tabOptions[i].oTD.onmouseout = function (event) { oThis.OnMouseOutMenu(event); };
		}
	}
}

WDBarreBoutonPopupMenu.prototype.OnMouseOverMenu = function (oEvent)
{
	// Indique quelle option est survolee
	var nOptionSurvol = this.__nGetOptionEvent(oEvent);
	if (this.nOptionSurvol != nOptionSurvol)
	{
		this.nOptionSurvol = nOptionSurvol;
	}

	// Rafraichit les options du sous menu si besoin
	this.__RafEtatOptions(oEvent);
}

WDBarreBoutonPopupMenu.prototype.OnMouseOutMenu = function (oEvent)
{
	// Indique quelle option est survolee
	var nOptionSurvol = this.__nGetOptionEvent(oEvent);
	if (this.nOptionSurvol == nOptionSurvol)
	{
		delete this.nOptionSurvol;
	}

	// Rafraichit les options du sous menu si besoin
	this.__RafEtatOptions(oEvent);
}

// Trouve l'option parent
WDBarreBoutonPopupMenu.prototype.__nGetOptionEvent = function (oEvent)
{
	var oSource = bIE ? oEvent.srcElement : oEvent.target;
	var i;
	var nLimiteI = this.m_tabOptions.length
	for (i = 0; i < nLimiteI; i++)
	{
		if (bEstFils(oSource, this.m_tabOptions[i].oTD, document))
		{
			return i;
		}
	}

	return -1;
}

// Rafraichit les options du sous menus
WDBarreBoutonPopupMenu.prototype.ExecuteCommande = function (oEvent)
{
	// Appel de la classe de base
	WDBarreBoutonPopup.prototype.ExecuteCommande.apply(this, [oEvent]);

	// Rafraichit les options du sous menu si besoin
	this.__RafEtatOptions(oEvent);
}

// Rafraichit les options du sous menu si besoin
WDBarreBoutonPopupMenu.prototype.__RafEtatOptions = function (oEvent)
{
	var i;
	var nLimiteI = this.m_tabOptions.length
	for (i = 0; i < nLimiteI; i++)
	{
		// Aucune option n'est survolee
		this.__RafEtatOption(oEvent, i, this.nOptionSurvol);
	}
}

// Rafraichit l'etat d'un bouton lors de l'ouverture du menu
WDBarreBoutonPopupMenu.prototype.__RafEtatOption = function (oEvent, nOption, nOptionSurvol)
{
	// Regarde si l'option est active
	var oOption = this.m_tabOptions[nOption];
	var nEtat = this.__nGetEtatSpecifiqueOption(oEvent, (nOption != nOptionSurvol) ? this.nEtat_Normal : this.nEtat_Survol, oOption);

	// Puis dessine l'etat
	if (nEtat != oOption.m_nEtat)
	{
		if (nEtat != this.nEtat_Normal)
		{
			oOption.m_nEtat = nEtat;
		}
		else
		{
			delete oOption.m_nEtat;
		}
		oOption.oTD.style.backgroundImage = this.m_oObjetParent.sGetImageBouton(nEtat);
	}
}

// Regarde si l'option est active
WDBarreBoutonPopupMenu.prototype.__nGetEtatSpecifiqueOption = function (oEvent, nEtat, oOption)
{
	// Si on a un etat surcharge
	return this.m_oObjetParent.bActifOption(oEvent, oOption.oParamCommande) ? this.nEtat_Actif : nEtat;
}

// Clic sur une option : trouve la commande associe et l'execute
WDBarreBoutonPopupMenu.prototype.OnClickP = function (oEvent)
{
	// Trouve l'option parent
	var nOption = this.__nGetOptionEvent(oEvent)
	if (nOption != -1)
	{
		// Fixe les parametres de la commande
		this.m_oParamCommande = this.m_tabOptions[nOption].oParamCommande;
	}

	// Appel la methode dans ExecuteCommande en evitant l'implementation de la classe parent
	WDBarreBouton.prototype.ExecuteCommande.apply(this, [oEvent]);

	// Appel de la classe de base (ferme le menu)
	WDBarreBoutonPopup.prototype.OnClickP.apply(this, [oEvent]);
}

// Manipulation d'une popup "menu" avec selection du bouton parent si un des fils est selectionne
function WDBarreBoutonPopupMenuS (oObjetParent, oBouton, sCommande, oPopup, tabOptions)
{
	// Appel explicite de l'initialisation de la classe de base
	if (oObjetParent)
	{
		this._Init(oObjetParent, oBouton, sCommande, null, oPopup, tabOptions);
	}
}

// Declare l'heritage
WDBarreBoutonPopupMenuS.prototype = new WDBarreBoutonPopupMenu();
// Surcharge le constructeur qui a ete efface
WDBarreBoutonPopupMenuS.prototype.constructor = WDBarreBoutonPopupMenuS;

// Declare les fonction une par une

// Initialisation du menu
WDBarreBoutonPopupMenuS.prototype._Init = function (oObjetParent, oBouton, sCommande, oParamCommande, oPopup, tabOptions)
{
	// Appel de la methode de la classe de base
	WDBarreBoutonPopupMenu.prototype._Init.apply(this, [oObjetParent, oBouton, sCommande, oParamCommande, oPopup, tabOptions]);
}

// Calcule l'etat specifique du bouton : inchange
WDBarreBoutonPopupMenuS.prototype.nGetEtatSpecifique = function (oEvent, nEtat, oDataEtat)
{
	// Si on a une option d'activee
	var i;
	var nLimiteI = this.m_tabOptions.length
	for (i = 0; i < nLimiteI; i++)
	{
		if (this.m_oObjetParent.bActifOption(oEvent, this.m_tabOptions[i].oParamCommande))
		{
			return this.nEtat_Actif;
		}
	}

	// Aucune option du menu n'est active : appele la methode de la classe de base
	return WDBarreBoutonPopupMenu.prototype.nGetEtatSpecifique.apply(this, [oEvent, nEtat, oDataEtat]);
}

// Classe de base pour un champ avec une barre
function WDBarre ()
{

}

WDBarre.prototype =
{
	m_sImageSurvolDefaut:	"Bkg_Mover.gif",
	m_sImageActifDefaut:	"Bkg_Select.gif",
	m_nModeBarreAutomatique:0,
	m_nModeBarreToujours:	1,
	m_nModeBarreJamais:		2,
	m_nBoutonOnOff:			0,		// WDSaisieRicheBtn
	m_nBoutonPopup:			1,		// WDBarreBoutonPopup
	m_nBoutonAction:		2,		// WDSaisieRicheBtnC
	m_nCombo:				3,		// WDSaisieRicheCbm
	m_nBoutonPopupMenu:		4,		// WDBarreBoutonPopupMenu
	m_nBoutonPopupMenuS:	5,		// WDBarreBoutonPopupMenuS
	m_sSuffixeCommande:		"_COM",

	// Initisalisation dans le constucteur
	_Init:function (sAliasChamp, eModeBarre, sImageSurvol, sImageActif)
	{
		// Alias du champ
		this.m_sAliasChamp = sAliasChamp;
		// Mode de la barre
		this.m_eModeBarre = (eModeBarre !== undefined) ? eModeBarre : this.m_nModeBarreAutomatique;
		// Image de survol
		this.m_tabImagesBoutons = new Array();
		this.m_tabImagesBoutons[WDBarreBouton.prototype.nEtat_Normal] = "";
		this.m_tabImagesBoutons[WDBarreBouton.prototype.nEtat_Survol] = sImageSurvol ? sImageSurvol : (_WD_ + "res/" + this.m_sImageSurvolDefaut);
		this.m_tabImagesBoutons[WDBarreBouton.prototype.nEtat_Actif] = sImageActif ? sImageActif : (_WD_ + "res/" + this.m_sImageActifDefaut);
	},

	// Initialisation dans l'init
	_InitBarre:function ()
	{
		this.m_oBarre = this.oGetElementById(document, this.m_sSuffixeCommande);

		// Selon le mode de la barre
		switch (this.m_eModeBarre)
		{
		// Toujours :
		case this.m_nModeBarreToujours:
			this.m_oBarre.style.display = "block";
			// Utilise la definition par la classe derive pour le hook du rafraichissement
			this._InitBarreAutomatique();
			break;
		// Jamais:
		case this.m_nModeBarreJamais:
			// Rien
			break;
		// Automatique
		case this.m_nModeBarreAutomatique:
		default:
			// Utilise la definition par la classe derive
			this._InitBarreAutomatique();
			break;
		}

		// Initialise les boutons de la barre
		this.m_tabBarreElements = new Array();
		this._InitBarreBoutons();
	},

	// Ajoute un boutons
	_AjouteBouton:function (oBouton)
	{
		this.m_tabBarreElements.push(oBouton);
	},

	sGetNomElement:function (sSuffixe)
	{
		return this.m_sAliasChamp + sSuffixe;
	},

	oGetElementById:function (oDocument, sSuffixe)
	{
		return oDocument.getElementById(this.sGetNomElement(sSuffixe));
	},

	oGetElementByIdBarre:function (oDocument, sSuffixe)
	{
		// Trouve l'element
		var oElement = this.oGetElementById(oDocument, this.m_sSuffixeCommande + "_" + sSuffixe);

		// Et en profite pour lui donner son texte alternatif
		if (oElement)
		{
			this.__sAppliqueBulle(oElement, sSuffixe);
		}
		return oElement;
	},

	// Met a jour la barre d'outils
	RafBarre: function (oEvent, bAfficheBarre)
	{
		// Selon le mode de la barre
		switch (this.m_eModeBarre)
		{
		// Jamais : rien a faire
		case this.m_nModeBarreJamais:
			// Rien
			break;

		// Automatique : calcule l'etat de la barre
		case this.m_nModeBarreAutomatique:
		default:
			// Et affiche la barre si besoin
			if (bAfficheBarre)
			{
				// Affiche la barre
				this.m_oBarre.style.display = "block";
			}
			else
			{
				// Masque la barre
				this.m_oBarre.style.display = "none";
				// Pas besoin de la MAJ des boutons
				break;
			}
			// Pas de break;

		// Toujours + automatique : MAJ des boutons
		case this.m_nModeBarreToujours:
			var oDataEtat = this.oGetParamEtat(oEvent, false);

			// Demande a chaque element de la barre
			var i;
			var nLimiteI = this.m_tabBarreElements.length;
			for (i = 0; i < nLimiteI; i++)
			{
				this.m_tabBarreElements[i].RafEtat(oEvent, oDataEtat);
			}
			break;
		}
	},

	// Recupere les parametres pour RafEtat
	oGetParamEtat:function (oEvent, bSimple)
	{
		return null;
	},

	// Recupere l'image de fond des bouton
	// 0 : Normal
	// 1 : Survol
	// 2 : Actif
	sGetImageBouton:function (nEtat)
	{
		var sImage = this.m_tabImagesBoutons[nEtat];
		if (sImage.length > 0)
		{
			return "url(" + sImage + ")";
		}
		else
		{
			return "";
		}
	},
	
	// Applique la bulle  l'element
	__sAppliqueBulle:function (oElement, sSuffixe)
	{
		var sAltTexte = this.sGetAltText(sSuffixe);
		if (sAltTexte)
		{
			// Traite le cas des images
			var tabFils = oElement.getElementsByTagName("IMG");
			if (tabFils.length)
			{
				tabFils[0].alt = sAltTexte;
			}
			// Traite le cas des combos
			tabFils = oElement.getElementsByTagName("SELECT");
			if (tabFils.length)
			{
				tabFils[0].title = sAltTexte;
			}
		}
	},

	// Recupere le texte alternatif d'un bouton
	// A surcharger par les classes derivees si besoin
	sGetAltText:function (sSuffixe)
	{
		return null;
	}
};
